StartupEvents.registry("palladium:abilities", event => {

    event.create("viper/psioni_blasts")
	
			.icon(palladium.createItemIcon('palladium:vibranium_circuit'))

			.documentationDescription('Does damage to what the executer is looking at.')

			.addProperty("damage", "float", 10.0, "The amount of damage the ability does")
			.addProperty('damage_type', 'string', 'minecraft:player_attack', 'The type of damage that is done')
			.addProperty('effect', 'string', 'null', 'The effect that is give to the entity if used')
			.addProperty('potion_seconds', 'integer', 0, 'How many seconds the entity should have the effect')
			.addProperty('potion_amplifier', 'integer', 0, 'What level the effect is')
			.addProperty("hide_particles", 'boolean', false, "If potion particles should be visable")
			.addProperty("range", "float", 32.0, "The amount of range the ability has")
			.addProperty('at', 'string', 'null', 'Where the damage is(by and from will not work if this is not null)')
			.addProperty('by', 'string', '@s', 'What entity is doing the damage')
			.addProperty('from', 'string', '@s', 'What entity is the damage from')
			.addProperty('command_as_entity', 'string', 'null', 'Excute a command from the entity if used')
			.addProperty('excluded_tag', 'string', 'damage_excluded_tag', 'Tag that will be excluded from damage if used')
			
			.tick((entity, entry, holder, enabled) => {
				if (enabled) {
					const damage = entry.getPropertyByName('damage');
					const damage_type = entry.getPropertyByName('damage_type');
					const effect = entry.getPropertyByName('effect');
					const potion_seconds = entry.getPropertyByName('potion_seconds');
					const potion_amplifier = entry.getPropertyByName('potion_amplifier');
					const hide_particles = entry.getPropertyByName('hide_particles');
					const range = entry.getPropertyByName('range');
					const at = entry.getPropertyByName('at');
					const by = entry.getPropertyByName('by');
					const from = entry.getPropertyByName('from');
					const command_as_entity = entry.getPropertyByName('command_as_entity');
					const excluded_tag = entry.getPropertyByName('excluded_tag');
	
					let target = entity.rayTrace(range).entity;
					if (enabled && target !== null && !containsTag(target.getTags().toArray(), excluded_tag) && at == null) {
						let target = entity.rayTrace(range).entity
						entity.runCommandSilent(`execute as ${target.uuid} at ${target.uuid} run ${command_as_entity}`)
						entity.runCommandSilent(`damage ${target.uuid} ${damage} ${damage_type} by ${by} from ${from}`)
					}
					if (enabled && target !== null && !containsTag(target.getTags().toArray(), excluded_tag) && at !== null) {
						let target = entity.rayTrace(range).entity
						entity.runCommandSilent(`execute as ${target.uuid} at ${target.uuid} run ${command_as_entity}`)
						entity.runCommandSilent(`damage ${target.uuid} ${damage} ${damage_type} at ${at}`)
					}
				}
		})
	});
	
	function containsTag(tags, tag) {
		for (let i = 0; i < tags.length; i++) {
			if(tags[i].equals(tag)) {
				return true;
			}
		}
		return false;
	}
	